// ExcTypes.cpp: Example program illustrating the throwing and handling of
//               different types of exceptions.

#include <iostream.h>

class CExcept
{
public:
   CExcept (int ExCode)
      {
      m_ExCode = ExCode;
      }
   int GetExCode ()
      {
      return m_ExCode;
      }
private:
   int m_ExCode;
};


void main ()
   {
   char Ch;

   try
      {
      cout << "at beginning of try block" << '\n';

      cout << "throw 'char *' exception? (y/n): "; cin >> Ch;
      if (Ch == 'y' || Ch == 'Y')
         throw "error description";

      cout << "throw 'int' exception? (y/n): "; cin >> Ch;
      if (Ch == 'y' || Ch == 'Y')
         throw 1;

      cout << "throw 'class CExcept' exception? (y/n): "; cin >> Ch;
      if (Ch == 'y' || Ch == 'Y')
         throw CExcept (5);

      cout << "throw 'double' exception? (y/n): "; cin >> Ch;
      if (Ch == 'y' || Ch == 'Y')
         throw 3.1416;

      cout << "at end of try block (no exceptions thrown)" << '\n';
      }
   catch (char *ErrorMsg)
      {
      cout << "'char *' exception thrown; exception message: " 
           << ErrorMsg << '\n';
      }
   catch (int ErrorCode)
      {
      cout << "'int' exception thrown; exception code: " << ErrorCode << '\n';
      }
   catch (CExcept Except)
      {
      cout << "'class CExcept' exception thrown; code: " 
           << Except.GetExCode () << '\n';
      }
   catch (...)
      {
      cout << "unknown type of exception thrown" << '\n';
      }
   cout << "after last catch block" << '\n';  
   }
